



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>卷积层和BN层融合</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">卷积层和BN层融合</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 15:44:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>常规的神经网络连接结构如下</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1182370/201808/1182370-20180827170732674-1953691984.png" />￼</p>
<p>当网络训练完成, 在推导的时候为了加速运算, 通常将卷积层和 batch-norm 层融合, 原理如下</p>
<p>\[<br />
\begin{align*}<br />
y_{conv} &amp;= w \cdot x + b \\<br />
y_{bn} &amp;= \gamma \cdot \left (\frac{y_{conv} - E[x]}{\sqrt{Var[x] + \epsilon}} \right)+\beta \\<br />
&amp;= \gamma \cdot \left (\frac{wx+b - E[x]}{\sqrt{ Var[x] + \epsilon}} \right)+\beta \\<br />
\hat w &amp;= \frac{\gamma}{\sqrt{Var[x] + \epsilon}}\cdot w \\<br />
\hat b &amp;= \frac{\gamma}{\sqrt{Var[x] + \epsilon}}\cdot \left({b - E[x]} \right)+\beta \\<br />
y_{bn} &amp;= \hat w \cdot x + \hat b \\<br />
\end{align*}<br />
\]</p>
<blockquote><p>推导时, E[x] 为 runnin_mean(滑动均值), Var[x] 为 running_var(滑动方差),<br />
pytorch 的 running_var 存储的是方差, 而不是标准差</p></blockquote>
<p>caffe 中的 conv-bn-scale-relu 结构</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1182370/201808/1182370-20180827172340224-1726619307.png" />￼</p>
<p>caffe模型的转化可以参考<a href="https://github.com/sanghoon/pva-faster-rcnn/blob/master/tools/gen_merged_model.py" rel="external nofollow noreferrer">pvanet</a>的卷积层和 batch-norm融合代码</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mvex68.html">分布式缓存之 memcache 实现分布式缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyjk5gq.html">repeater没有数据显示暂无数据&comma;无记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1g7039.html">Y2K Accounting Bug                                                       分类：            POJ             2015-06-16 16&colon;55    14人阅读    评论&lpar;0&rpar;    收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmm0j79.html">python 练习 26</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xwr3w9.html">ASP isPostBack</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okyzxe9.html">LVS三种模式配置及优点缺点比较 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmk0p49.html">Dynamices CRM JS 类库 神器 XrmServiceToolkit - A Microsoft Dynamics CRM 2011 &amp;amp&semi; CRM 2013 JavaScript Library</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm2r6x9.html">【HDOJ】1753 大明A&plus;B</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydzgldq.html">Ajax中send方法参数的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjvrlg8.html">Android开发之Ubuntu上Eclipse不显示手机设备</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjlg6r8.html">SpringMVC 学习-拦截器 HandlerInterceptor 类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j3n138.html">利用python发送邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kwz559.html">wpf中内置资源文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gje4kz9.html">OrderBy排序和IComparer的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4j6rx9.html">go微服务框架go-micro深度学习-目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wz64q.html">Android模拟微信主页面的Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ord7k8.html">ssm  配置多个数据源</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjeeljq.html">如何解决每次打开office 都会出现正在配置的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/953l3x68.html">USB 之传输编码格式 NRZI 介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm4nze9.html">SQL中減少日志文件大小</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zyrr4x9.html">1411 - Ants&lpar;巨人与鬼&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2zzly9.html">因子分析factor analysis&lowbar;spss运用&lowbar;python建模&lpar;推荐AAA&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gmj3vq.html">ansible 基础一</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2lpyoq.html">OS &plus; Windows 10 &sol; office excel vlookup &sol; CredSSP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy453xq.html">python socket原理 及socket如何使&lpar;tcp udp协议&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7olddg8.html">ruby新建web项目步骤，使用mysql数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2lkxoq.html">Ubuntu18&period;04 关闭和开启图形界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e453ox9.html">&lbrack;leetcode-128&rsqb; 最长连续序列</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj4xx49.html">HanLP二元核心词典解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwdldv9.html">SQL行列转置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
